package com.huimv.production.autoGetData.config;

import com.huimv.production.autoGetData.service.IAutoGetErpData;
import com.huimv.production.autoGetData.service.impl.AutoGetErpDataImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.scheduling.annotation.SchedulingConfigurer;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.text.ParseException;
import java.time.LocalDateTime;
import java.util.List;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Configuration      //1.主要用于标记配置类，兼备Component的效果。
@EnableScheduling   // 2.开启定时任务
@RestController
public class SaticScheduleTask  {
    @Autowired
    private IAutoGetErpData iAutoGetErpData;

//    @Scheduled(cron = "* 0/5 * * * ?")
//    //或直接指定时间间隔，例如：5秒
//    //@Scheduled(fixedRate=5000)
//    private void configureTasks() {
//        System.err.println("执行静态定时任务时间: " + LocalDateTime.now());
//    }



//    @Scheduled(cron = "0/5 * * * * ?")
//    @Scheduled(cron = "0 * * * * ? ")
    private void getPsyTask(){
        System.err.println("执行 getPsyTask 执行静态定时任务时间: " + LocalDateTime.now());
        iAutoGetErpData.getPsy();
    }


//    @Scheduled(cron = "* 0/5 * * * ?")
//    @Scheduled(cron = "0 * * * * ? ")
    private void getReEstrusRate(){
        System.err.println("执行 getReEstrusRate 执行静态定时任务时间: " + LocalDateTime.now());
        iAutoGetErpData.getReEstrusRate();
    }

//    @Scheduled(cron = "* 0/5 * * * ?")
//    @Scheduled(cron = "0 * * * * ? ")
    private void getParturitionRate(){
        System.err.println("执行 getParturitionRate 执行静态定时任务时间: " + LocalDateTime.now());
        iAutoGetErpData.getParturitionRate();
    }

//    @Scheduled(cron = "* 0/5 * * * ?")
//@Scheduled(cron = "0 * * * * ? ")
    @RequestMapping("/getStorage")
    private List getStorage(){
        System.err.println("执行 getStorage 执行静态定时任务时间: " + LocalDateTime.now());
       return iAutoGetErpData.getStorage();
    }


//    @Scheduled(cron = "0 * * * * ? ")
    private void getPigletInfo(){
        System.err.println("执行 getPigletInfo 执行静态定时任务时间: " + LocalDateTime.now());
        iAutoGetErpData.getPigletInfo();
    }

//    @Scheduled(cron = "0 * * * * ? ")
    private void getMateQuantity(){
        System.err.println("执行 getMateQuantity 执行静态定时任务时间: " + LocalDateTime.now());
        iAutoGetErpData.getMateQuantity();
    }

//    @Scheduled(cron = "0 * * * * ? ")
    private void getConceptionRate(){
        System.err.println("执行 getConceptionRate 执行静态定时任务时间: " + LocalDateTime.now());
        iAutoGetErpData.getConceptionRate();
    }

//    @Scheduled(cron = "0 * * * * ? ")
    private void getAllStorage(){
        System.err.println("执行 getAllStorage 执行静态定时任务时间: " + LocalDateTime.now());
        iAutoGetErpData.getAllStorage();

    }


    @RequestMapping("/findAll")
    private List findAll(){

        return iAutoGetErpData.findAll();
    }

    //ok
    //
//    @Scheduled(cron = "0 0/60 * * * ?")
    private void getManyFarmProduce() throws IOException {
        //获取多牧场生产数
        iAutoGetErpData.getManyFarmProduce();
//        iAutoGetErpData.getManyFarmPsy();
    }

    //ok
//    @Scheduled(cron = "0 0/60 * * * ?")
    private void getManyFarmStock() throws IOException {
        //获取多牧场存栏
        iAutoGetErpData.getManyFarmStock();
    }

    //ok
//    @Scheduled(cron = "0 0/60 * * * ?")
    private void getCostWithManyFarm() throws IOException, ParseException {
        //获取多牧场生产成本
        iAutoGetErpData.getCostWithManyFarm();
    }

    // ok
//    @Scheduled(cron = "0 0/60 * * * ?")
    private void getWarningMessage() throws IOException, ParseException {
        //获取预警信息
        iAutoGetErpData.getWarningMessage();
    }

    //ok
//    @Scheduled(cron = "0 0/60 * * * ?")
    private void getWorkPlan() throws IOException, ParseException {
        //工作计划
        iAutoGetErpData.getWorkPlan();
    }

    //ok
//    @Scheduled(cron = "0 0/60 * * * ?")
    private void getPrepareStatusQuantity() throws IOException, ParseException {
        //获取各种准备状态数量
        iAutoGetErpData.getPrepareStatusQuantity();
    }

    //ok
//    @Scheduled(cron = "0 0/60 * * * ?")
    private void getPayable() throws IOException, ParseException {
        //应付排名
        iAutoGetErpData.getPayable();
    }

    //ok
//    @Scheduled(cron = "0 0/60 * * * ?")
    private void getSales() throws IOException, ParseException {
        System.out.println("");
        //读取销售数据
        iAutoGetErpData.getSales();
    }

    @Scheduled(cron = "0 0/2 * * * ?")
    private void getManyFarmPsy() throws IOException, ParseException {
        System.out.println("");
        //读取多个牧场的PSY
        iAutoGetErpData.getManyFarmPsy();
    }
}
