package com.huimv.production.autoGetData.repo;

import com.huimv.production.autoGetData.entity.ProdStockEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

public interface ProdStockRepo extends JpaRepository<ProdStockEntity, Integer>, JpaSpecificationExecutor<ProdStockEntity> {

    @Transactional
    @Modifying(clearAutomatically = true)
    @Query(nativeQuery = true ,value = "DELETE FROM prod_stock WHERE year=?1 AND month=?2")
    void deleteByYearAndMonth(int year, int month);
}